
awacs = {}

awacs.debugmode = false

awacs.coaRED     = coalition.side.RED
awacs.coaBLUE    = coalition.side.BLUE
awacs.coaNEUTRAL = coalition.side.NEUTRAL

-- coalition lookup tables
awacs.enemyCoa = {}
awacs.enemyCoa[ awacs.coaRED     ] = awacs.coaBLUE
awacs.enemyCoa[ awacs.coaBLUE    ] = awacs.coaRED
awacs.enemyCoa[ awacs.coaNEUTRAL ] = nil

awacs.coaName = {}
awacs.coaName[ awacs.coaRED      ] = 'RED'
awacs.coaName[ awacs.coaBLUE     ] = 'BLUE'
awacs.coaName[ awacs.coaNEUTRAL  ] = 'NEUTRAL'

awacs.awacsUnits                 =   {}
awacs.unitsDB                    =   {}
awacs.awacsVars                  =   {}
awacs.awacsExceptions            =   {} --awacs.awacsExceptions[#awacs.awacsExceptions + 1] = "Vespa 4" -- example
awacs.scrambleCommandsInstalled  =   {}
awacs.awacsCommandsInstalled     =   {}

-- AWACS defaults
awacs.awacsRange                            =    75	-- Options: 25, 50, 75, 100, 150, 200
awacs.awacsDisplay                          =    'off'	-- Options: 'on' or 'off'
awacs.awacsWarning                          =    'on'	-- Options: 'on' or 'off'
awacs.awacsReference						=	 'Self' -- Options: 'Self' or 'Bullseye'
awacs.awacsLimitAirframes                   =    true
awacs.awacsUseThreatLevels                  =    true
awacs.awacsUseLOS							=	 true

-- If awacsUseThreatLevels = true, AWACS recipients will only see enemy a/c with higher threat levels than their own,
-- i.e. helos will see both fighters and strikers; strikers will see only fighters.
-- Enemy types deemed 'NOTHREAT' such as bomber, transport, reconnaisance, and refueler will not be displayed.
-- Types not defined below are presumed to be fighters. (There should be no undefined types, but just in case...)
-- Threat filter is applied to enemy a/c only; all friendlies will be displayed (if menu item 'Picture - Friendly' or 'Picture - All' is enabled).

-- Threat levels
awacs.NOTHREAT = 0
awacs.HELO     = 1
awacs.STRIKER  = 2
awacs.FIGHTER  = 3

-- set threat levels by a/c type; types from {DCS}\scripts\database\db_countries.lua
awacs.acThreatLevel = {
[ "A-10A"          ] = awacs.STRIKER    ,
[ "A-10C"          ] = awacs.STRIKER    ,
[ "A-50"           ] = awacs.NOTHREAT   ,
[ "AH-1W"          ] = awacs.HELO       ,
[ "AH-64A"         ] = awacs.HELO       ,
[ "AH-64D"         ] = awacs.HELO       ,
[ "An-26B"         ] = awacs.NOTHREAT   ,
[ "An-30M"         ] = awacs.NOTHREAT   ,
[ "B-1B"           ] = awacs.NOTHREAT   ,
[ "B-52H"          ] = awacs.NOTHREAT   ,
[ "Bf-109K-4"      ] = awacs.STRIKER    ,-- added since last update
[ "C-101EB"        ] = awacs.STRIKER    ,-- added since last update
[ "C-130"          ] = awacs.NOTHREAT   ,
[ "C-17A"          ] = awacs.NOTHREAT   ,
[ "CH-47D"         ] = awacs.HELO       ,
[ "CH-53E"         ] = awacs.HELO       ,
[ "E-2C"           ] = awacs.NOTHREAT   ,
[ "E-3A"           ] = awacs.NOTHREAT   ,
[ "F-111F"         ] = awacs.FIGHTER    ,-- added since last update
[ "F-117A"         ] = awacs.STRIKER    ,
[ "F-14A"          ] = awacs.FIGHTER    ,
[ "F-15C"          ] = awacs.FIGHTER    ,
[ "F-15E"          ] = awacs.FIGHTER    ,
[ "F-16A"          ] = awacs.FIGHTER    ,
[ "F-16A MLU"      ] = awacs.FIGHTER    ,
[ "F-16C bl.50"    ] = awacs.FIGHTER    ,
[ "F-16C bl.52d"   ] = awacs.FIGHTER    ,
[ "F-4E"           ] = awacs.FIGHTER    ,
[ "F-5E"           ] = awacs.FIGHTER    ,
[ "F-86F Sabre"    ] = awacs.STRIKER    ,
[ "F/A-18A"        ] = awacs.FIGHTER    ,-- added since last update
[ "F/A-18C"        ] = awacs.FIGHTER    ,
[ "FW-190D9"       ] = awacs.STRIKER    ,
[ "Hawk"           ] = awacs.STRIKER    ,-- added since last update
[ "IL-76MD"        ] = awacs.NOTHREAT   ,
[ "IL-78M"         ] = awacs.NOTHREAT   ,
[ "KC-135"         ] = awacs.NOTHREAT   ,
[ "Ka-27"          ] = awacs.HELO       ,
[ "Ka-50"          ] = awacs.HELO       ,
[ "Ka-52"          ] = awacs.HELO       ,
[ "L-39ZA"         ] = awacs.STRIKER    ,
[ "MQ-9 Reaper"    ] = awacs.NOTHREAT   ,-- added since last update
[ "Mi-24V"         ] = awacs.HELO       ,
[ "Mi-26"          ] = awacs.HELO       ,
[ "Mi-28N"         ] = awacs.HELO       ,
[ "Mi-8MT"         ] = awacs.HELO       ,
[ "MiG-15bis"      ] = awacs.STRIKER    ,-- added since last update
[ "MiG-21Bis"      ] = awacs.FIGHTER    ,
[ "MiG-23MLD"      ] = awacs.FIGHTER    ,
[ "MiG-25PD"       ] = awacs.FIGHTER    ,
[ "MiG-25RBT"      ] = awacs.FIGHTER    ,
[ "MiG-27K"        ] = awacs.STRIKER    ,
[ "MiG-29A"        ] = awacs.FIGHTER    ,
[ "MiG-29G"        ] = awacs.FIGHTER    ,
[ "MiG-29K"        ] = awacs.FIGHTER    ,-- added since last update
[ "MiG-29S"        ] = awacs.FIGHTER    ,
[ "MiG-31"         ] = awacs.FIGHTER    ,
[ "Mirage 2000-5"  ] = awacs.FIGHTER    ,
[ "OH-58D"         ] = awacs.HELO       ,
[ "P-51D"          ] = awacs.STRIKER    ,
[ "RQ-1A Predator" ] = awacs.NOTHREAT   ,
[ "S-3B"           ] = awacs.NOTHREAT   ,
[ "S-3B Tanker"    ] = awacs.NOTHREAT   ,
[ "SH-3W"          ] = awacs.HELO       ,
[ "SH-60B"         ] = awacs.HELO       ,
[ "Su-17M4"        ] = awacs.STRIKER    ,
[ "Su-24M"         ] = awacs.STRIKER    ,
[ "Su-24MR"        ] = awacs.STRIKER    ,
[ "Su-25"          ] = awacs.STRIKER    ,
[ "Su-25T"         ] = awacs.STRIKER    ,
[ "Su-25TM"        ] = awacs.STRIKER    ,
[ "Su-27"          ] = awacs.FIGHTER    ,
[ "Su-30"          ] = awacs.FIGHTER    ,
[ "Su-33"          ] = awacs.FIGHTER    ,
[ "Su-34"          ] = awacs.FIGHTER    ,
[ "TF-51D"         ] = awacs.STRIKER    ,-- added since last update
[ "Tornado GR4"    ] = awacs.STRIKER    ,
[ "Tornado IDS"    ] = awacs.STRIKER    ,
[ "Tu-142"         ] = awacs.NOTHREAT   ,
[ "Tu-160"         ] = awacs.NOTHREAT   ,
[ "Tu-22M3"        ] = awacs.NOTHREAT   ,
[ "Tu-95MS"        ] = awacs.NOTHREAT   ,
[ "UH-1H"          ] = awacs.HELO       ,
[ "UH-60A"         ] = awacs.HELO       ,
[ "Yak-40"         ] = awacs.NOTHREAT   ,}

-- these types will receive AWACS display
awacs.validAwacsAirframes = {}
awacs.validAwacsAirframes[#awacs.validAwacsAirframes + 1] = "MiG-21Bis"



awacs.awacsWarningTable = {}
awacs.awacsWarningTable[#awacs.awacsWarningTable + 1] = "on"
awacs.awacsWarningTable[#awacs.awacsWarningTable + 1] = "off"

awacs.awacsReferenceTable = {}
awacs.awacsReferenceTable[#awacs.awacsReferenceTable + 1] = "Self"
awacs.awacsReferenceTable[#awacs.awacsReferenceTable + 1] = "Bullseye"

awacs.awacsRangeTable = {}
awacs.awacsRangeTable[#awacs.awacsRangeTable + 1] = 25
awacs.awacsRangeTable[#awacs.awacsRangeTable + 1] = 50
awacs.awacsRangeTable[#awacs.awacsRangeTable + 1] = 75
awacs.awacsRangeTable[#awacs.awacsRangeTable + 1] = 100
awacs.awacsRangeTable[#awacs.awacsRangeTable + 1] = 150
awacs.awacsRangeTable[#awacs.awacsRangeTable + 1] = 200

awacs.getDistance = function(obj1x, obj1y, obj2x, obj2y)
    local xDiff = obj1x - obj2x
    local yDiff = obj1y - obj2y
    return math.sqrt(xDiff * xDiff + yDiff * yDiff)
end

awacs.getBearing = function(obj1Pos, obj2Pos)
    bearing = math.atan2(obj2Pos.p.z - obj1Pos.p.z, obj2Pos.p.x - obj1Pos.p.x)
    if bearing < 0 then
        bearing = bearing + 2 * math.pi
    end
    bearing = bearing * 180 / math.pi
    return bearing    -- degrees
end

awacs.getHeading = function(vec)
    local heading = math.atan2(vec.z,vec.x)
    if heading < 0 then
        heading = heading + 2 * math.pi
    end
    heading = heading * 180 / math.pi
    return heading
end

awacs.isValidPlayer = function(unit, role)

    -- roles: 'awacs', 'scramble'
    local typeName
    local goodAirframe = false
    local pilotName
    local comparePilotName

    --Check for single-player first. If SP then allow anything.
    pilotName = string.upper(unit:getPlayerName())
    comparePilotName = string.sub(pilotName,1,string.len("NEW CALLSIGN"))
    if comparePilotName == "NEW CALLSIGN" then
        return true
    end

    --Check for valid airframes - slow movers only
    if awacs.awacsLimitAirframes then
        for i=1,#awacs.validAwacsAirframes do
            typeName = unit:getTypeName()
            if awacs.validAwacsAirframes[i] == typeName then
                goodAirframe = true
                break
            end
        end
    else
        goodAirframe = true
    end
	
    if role == 'awacs' and goodAirframe then
		return true
	else
		return false
    end

end

awacs.getAwacsUnits = function()

    awacs.awacsUnits = {}
    local iters = {}
	iters[#iters + 1] = {awacs.coaRED,Group.Category.AIRPLANE}
	iters[#iters + 1] = {awacs.coaBLUE,Group.Category.AIRPLANE}
    iters[#iters + 1] = {awacs.coaRED,Group.Category.HELICOPTER}
    iters[#iters + 1] = {awacs.coaBLUE,Group.Category.HELICOPTER}
    for m = 1,#iters do
        local groups = coalition.getGroups(iters[m][1],iters[m][2])
        for i=1,#groups do
            local group = groups[i]
            if group ~= nil then
                local groupID = group:getID()
                local units = group:getUnits()
               for j=1,#units do
                   local unit = units[j]
                   if unit ~= nil then
                        local unitID = unit:getID()
                        local playerName = unit:getPlayerName()
                        if playerName ~= nil then
                            if awacs.isValidPlayer(unit,'awacs') then
                                local unitName = unit:getName()
                                local isException = false
                                for k=1,#awacs.awacsExceptions do
                                    if unitName == awacs.awacsExceptions[k] then
                                        isException = true
                                        break
                                    end
                                end
                                if not isException then
                                    local range0     = awacs.awacsRange
                                    local warning0   = awacs.awacsWarning
                                    local display0   = awacs.awacsDisplay
                                    local reference0 = awacs.awacsReference
									local isHelo     = false
									if iters[m][2] == Group.Category.HELICOPTER then
										isHelo = true
									end
                                    if awacs.awacsVars[unitName] then -- use settings if they exist
                                        range0     = awacs.awacsVars[unitName].range
                                        warning0   = awacs.awacsVars[unitName].warning
                                        display0   = awacs.awacsVars[unitName].display
                                        reference0 = awacs.awacsVars[unitName].reference
                                    else -- use defaults if not
                                        awacs.awacsVars[unitName] = {}
                                        awacs.awacsVars[unitName].range      = awacs.awacsRange
                                        awacs.awacsVars[unitName].warning    = awacs.awacsWarning
                                        awacs.awacsVars[unitName].display    = awacs.awacsDisplay
                                        awacs.awacsVars[unitName].reference  = awacs.awacsReference
                                    end
                                    k = #awacs.awacsUnits + 1
                                    awacs.awacsUnits[k]             = {}
                                    awacs.awacsUnits[k].unitName    = unitName
                                    awacs.awacsUnits[k].isHelo      = isHelo
                                    awacs.awacsUnits[k].unitID      = unitID
                                    awacs.awacsUnits[k].groupID     = groupID
                                    awacs.awacsUnits[k].position    = {}
                                    awacs.awacsUnits[k].position    = unit:getPosition()
                                    awacs.awacsUnits[k].point       = unit:getPoint()
                                    awacs.awacsUnits[k].range       = range0
                                    awacs.awacsUnits[k].warning     = warning0
                                    awacs.awacsUnits[k].display     = display0
                                    awacs.awacsUnits[k].reference   = reference0
                                    awacs.awacsUnits[k].coalition   = iters[m][1]
                                    awacs.awacsUnits[k].coaName     = awacs.coaName[iters[m][1]]
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end

awacs.getNearestAirbase = function(coa,pos)
    rvals = {}
    local airdromes = {}
    local tmp = coalition.getAirbases(coa)
    for i=1,#tmp do
		local abDesc = tmp[i]:getDesc()
		if abDesc ~= nil and abDesc.category == Airbase.Category.AIRDROME then
			local pos2  = tmp[i]:getPosition()
			local j = #airdromes + 1
			airdromes[j] = {}
			airdromes[j].coa = coa
			airdromes[j].name = tmp[i]:getName()
			airdromes[j].pos = {}
			airdromes[j].pos = pos2
			airdromes[j].dist = awacs.getDistance(pos.p.x,pos.p.z,pos2.p.x,pos2.p.z)
			airdromes[j].brg = awacs.getBearing(pos,pos2) -- degrees
        end
    end

    function tsort(a1,a2)
        return a1.dist < a2.dist
    end
    if #airdromes > 1 then
        table.sort(airdromes,tsort)
    end

    if #airdromes > 0 then
		--for i=1,#airdromes do
		--	env.info(string.format("Airdrome[%d] %s %s %3.1f %03.1f",i,airdromes[i].coa,airdromes[i].name,airdromes[i].dist,airdromes[i].brg))
		--end
        return  airdromes[1]
    else
        return nil
    end
end

awacs.getAwacsIndex = function(unitName)
    for i=1,#awacs.awacsUnits do
        if unitName == awacs.awacsUnits[i].unitName then
            return i
        end
    end
end

awacs.setAwacsDisplay = function(selection)
    -- 'enemy', 'friendly', 'all', 'off'
    if selection ~= nil and type(selection) == 'table' then
        local index = awacs.getAwacsIndex(selection[2])
        if index ~= nil then
            awacs.awacsUnits[index].display = selection[1]
        end
        if not awacs.awacsVars[selection[2]] then
            awacs.awacsVars[selection[2]] = {}
        end
        awacs.awacsVars[selection[2]].display = selection[1]
    end
end

awacs.setAwacsWarning = function(selection)
    -- 'on', 'off'
    if selection ~= nil and type(selection) == 'table' then
        local index = awacs.getAwacsIndex(selection[2])
        if index ~= nil then
            awacs.awacsUnits[index].warning = awacs.awacsWarningTable[selection[1]]
        end
        if not awacs.awacsVars[selection[2]] then
            awacs.awacsVars[selection[2]] = {}
        end
        awacs.awacsVars[selection[2]].warning = awacs.awacsWarningTable[selection[1]]
    end
end

awacs.setAwacsRange = function(selection)
    -- 25, 50, 75, 100, 150, 200
    if selection ~= nil and type(selection) == 'table' then
        local index = awacs.getAwacsIndex(selection[2])
        if index ~= nil then
            awacs.awacsUnits[index].range = awacs.awacsRangeTable[selection[1]]
        end
        if not awacs.awacsVars[selection[2]] then
            awacs.awacsVars[selection[2]] = {}
        end
        awacs.awacsVars[selection[2]].range = awacs.awacsRangeTable[selection[1]]
    end
end

awacs.setAwacsReference = function(selection)
    -- 'Self', 'Bullseye'
    if selection ~= nil and type(selection) == 'table' then
        local index = awacs.getAwacsIndex(selection[2])
        if index ~= nil then
            awacs.awacsUnits[index].reference = awacs.awacsReferenceTable[selection[1]]
        end
        if not awacs.awacsVars[selection[2]] then
            awacs.awacsVars[selection[2]] = {}
        end
        awacs.awacsVars[selection[2]].reference = awacs.awacsReferenceTable[selection[1]]
    end
end

awacs.installAwacsCommands = function(unitName)
    if awacs.awacsCommandsInstalled[unitName] == nil then

        local unit = Unit.getByName(unitName)
        if unit == nil then
            return
        end
        local group = unit:getGroup()
        if group == nil then
            return
        end
        local coa = unit:getCoalition()
        if coa == nil then
            return
        end
       local gid = group:getID()

        local awacsMainMenu      = missionCommands.addSubMenuForGroup( gid, "AWACS Menu"              , nil                                                          )
        local awacsBlueCmd       = missionCommands.addCommandForGroup( gid, "Picture - ENEMY"         , awacsMainMenu, awacs.setAwacsDisplay, {'enemy'   , unitName} )
        local awacsRedCmd        = missionCommands.addCommandForGroup( gid, "Picture - FRIENDLY"      , awacsMainMenu, awacs.setAwacsDisplay, {'friendly', unitName} )
        local awacsAllCmd        = missionCommands.addCommandForGroup( gid, "Picture - ALL"           , awacsMainMenu, awacs.setAwacsDisplay, {'all'     , unitName} )
        local awacsOffCmd        = missionCommands.addCommandForGroup( gid, "Picture - OFF"           , awacsMainMenu, awacs.setAwacsDisplay, {'off'     , unitName} )
        local awacsRangeMenu     = missionCommands.addSubMenuForGroup( gid, "Set Max. Range"          , awacsMainMenu                                                )
        local awacsWarningMenu   = missionCommands.addSubMenuForGroup( gid, "Set Auto Threat Warning" , awacsMainMenu                                                )
        local awacsReferenceMenu = missionCommands.addSubMenuForGroup( gid, "Set BRA Reference"       , awacsMainMenu                                                )

        for i=1, #awacs.awacsRangeTable do
            missionCommands.addCommandForGroup(gid, awacs.awacsRangeTable[i], awacsRangeMenu, awacs.setAwacsRange, {i,unitName})
        end
        for i=1, #awacs.awacsWarningTable do
            missionCommands.addCommandForGroup(gid, awacs.awacsWarningTable[i], awacsWarningMenu, awacs.setAwacsWarning, {i,unitName})
        end
        for i=1, #awacs.awacsReferenceTable do
            missionCommands.addCommandForGroup(gid, awacs.awacsReferenceTable[i], awacsReferenceMenu, awacs.setAwacsReference, {i,unitName})
        end

        awacs.awacsCommandsInstalled[unitName] = true

    end
end

awacs.updateUnitsDB = function()
	awacs.unitsDB = {}
    local iters = {}
    iters[#iters + 1] = {awacs.coaRED ,Group.Category.AIRPLANE}
    iters[#iters + 1] = {awacs.coaBLUE,Group.Category.AIRPLANE}
    iters[#iters + 1] = {awacs.coaRED ,Group.Category.HELICOPTER}
    iters[#iters + 1] = {awacs.coaBLUE,Group.Category.HELICOPTER}
    for m = 1,#iters do
        local groups = coalition.getGroups(iters[m][1],iters[m][2])
        for i=1,#groups do
            local group = groups[i]
            if group ~= nil then
                local units = group:getUnits()
                for j=1,#units do
                    local ai
                    local unit = units[j]
                    if unit ~= nil and unit:isActive() then
                        local unitType = unit:getTypeName()
                        if unitType == nil then
                            unitType = 'Unknown'
                        end
                        playerName = unit:getPlayerName()
                        if playerName ~= nil then    --human controlled
                            ai = false
                        else -- ai
                            ai = true
                            playerName = 'AI'
                        end
                        --add unit to unitsDB
                        k = #awacs.unitsDB + 1
                        awacs.unitsDB[k] = {}
                        awacs.unitsDB[k].coalition    =   iters[m][1]
                        awacs.unitsDB[k].coaName      =   awacs.coaName[iters[m][1]]
                        awacs.unitsDB[k].groupID      =   group:getID()
                        awacs.unitsDB[k].groupName    =   group:getName()
                        awacs.unitsDB[k].unitID       =   unit:getID()
                        awacs.unitsDB[k].unitName     =   unit:getName()
                        awacs.unitsDB[k].unitType     =   unitType
                        awacs.unitsDB[k].playerName   =   playerName
                        awacs.unitsDB[k].ai           =   ai
                        awacs.unitsDB[k].position     =   {}
                        awacs.unitsDB[k].position     =   unit:getPosition()       -- pos3 = {p = {x, y, z}, x = {x, y, z}, y = {x, y, z}, z = {x, y, z}}
                        awacs.unitsDB[k].point        =   {}
                        awacs.unitsDB[k].point        =   unit:getPoint()          -- vec3 = {x, y, z}
                        awacs.unitsDB[k].velocity     =   {}
                        awacs.unitsDB[k].velocity     =   unit:getVelocity()       -- vec3 = {x, y, z}
                        awacs.unitsDB[k].inAir        =   unit:inAir()
                        awacs.unitsDB[k].heading      =   awacs.getHeading(awacs.unitsDB[k].position.x)
                        awacs.unitsDB[k].altitude     =   awacs.unitsDB[k].point.y       -- m
                        awacs.unitsDB[k].speed        =   math.sqrt(awacs.unitsDB[k].velocity.x^2 + awacs.unitsDB[k].velocity.y^2 + awacs.unitsDB[k].velocity.z^2)   -- m/s
                    end
                end
            end
        end
    end
end

awacs.updateAwacs = function()

    awacs.updateUnitsDB()

    local function tsort(u1,u2)
        if u1.sortVal == u2.sortVal then    -- if same coalition then
            return u1.range < u2.range      -- closest units first
        else
            return u1.sortVal < u2.sortVal  -- else put enemy ahead of friendly
        end
    end

    for i=1,#awacs.awacsUnits do

        local tmp = {}
        local unitName     =   awacs.awacsUnits[i].unitName
        local unit         =   Unit.getByName(unitName)
		local unitType     =   unit:getTypeName()
        local awacsPos     =   unit:getPosition()
        local awacsPnt     =   unit:getPoint()
        local maxRange     =   awacs.awacsUnits[i].range
        local warning      =   awacs.awacsUnits[i].warning
        local display      =   awacs.awacsUnits[i].display
        local reference    =   awacs.awacsUnits[i].reference
        local coa          =   awacs.awacsUnits[i].coalition
        local awacsID      =   awacs.awacsUnits[i].groupID
        local displayCoa   =   awacs.coaNEUTRAL    -- dummy value

		local refPos = {}
		refPos.p = {}
		if reference == 'Self' then
			refPos = awacsPos
		else
			refPos.p = coalition.getMainRefPoint(coa)
		end
		
        if display == 'enemy' then
			displayCoa = awacs.enemyCoa[coa]
        elseif display == 'friendly' then
			displayCoa = coa
        end
		-- displayCoa is enemy, friendly, or neutral at this point
		-- neutral represents display selections 'all' or 'off'
        if warning == 'on' or display ~= 'off' then -- skip if warning = off and display = off
            for j=1,#awacs.unitsDB do
                local reciprocalBrg
                local refReciprocalBrg
                local bogeyPos = awacs.unitsDB[j].position
                local bogeyPnt = awacs.unitsDB[j].point
                local distance = awacs.getDistance(awacsPos.p.x,awacsPos.p.z,bogeyPos.p.x,bogeyPos.p.z) / 1000    -- km
                local refDistance = awacs.getDistance(refPos.p.x,refPos.p.z,bogeyPos.p.x,bogeyPos.p.z) / 1000    -- km
                local bearing  = awacs.getBearing(awacsPos,bogeyPos)     -- degrees
                local refBearing  = awacs.getBearing(refPos,bogeyPos)    -- degrees
				local los = land.isVisible(bogeyPnt,awacsPnt) or false
				
                if bearing < 180 then
                    reciprocalBrg = bearing + 180
                else
                    reciprocalBrg = bearing - 180
                end
				
                if refBearing < 180 then
                    refReciprocalBrg = refBearing + 180
                else
                    refReciprocalBrg = refBearing - 180
                end
				
                local bogeyCoa = awacs.unitsDB[j].coalition

                if distance <= maxRange and unitName ~= awacs.unitsDB[j].unitName then -- if within range and not yourself

                    local addBogey = false -- default position
                    if warning == 'on' and bogeyCoa ~= coa then -- enemy
                        addBogey = true
                    elseif display == 'all' then -- both enemy and friendly
                        addBogey = true
                    elseif displayCoa == bogeyCoa then -- either enemy or friendly depending on menu selection
                        addBogey = true
                    end

					if addBogey and awacs.awacsUseThreatLevels and bogeyCoa == awacs.enemyCoa[coa] then -- friendlies not subject to threat-level filtering
						local ownThreatLevel = awacs.acThreatLevel[unitType]
						local bogeyThreatLevel = awacs.acThreatLevel[awacs.unitsDB[j].unitType] or awacs.FIGHTER -- undefined type is presumed to be a fighter
						if not awacs.unitsDB[j].ai then 
							if bogeyThreatLevel <= ownThreatLevel then addBogey = false end
						else
							if bogeyThreatLevel < ownThreatLevel then addBogey = false end
						end
					end

                    local sortVal -- put enemies at top of list
					if bogeyCoa == awacs.enemyCoa[coa] then
						sortVal = 1
					else
						sortVal = 2
					end

					if awacs.awacsUseLOS == false then
						los = true
					end
					
                    if addBogey and los then
                        local k = #tmp + 1
                        tmp[k] = {}
                        tmp[k].coalition     = awacs.unitsDB[j].coalition
                        tmp[k].unitType      = awacs.unitsDB[j].unitType
                        tmp[k].bearing       = refBearing
                        tmp[k].reciprocalBrg = refReciprocalBrg
                        tmp[k].range         = refDistance
                        tmp[k].altitude      = awacs.unitsDB[j].altitude
                        tmp[k].speed         = awacs.unitsDB[j].speed
                        tmp[k].heading       = awacs.unitsDB[j].heading
                        tmp[k].sortVal       = sortVal
                        tmp[k].coaName       = awacs.coaName[awacs.unitsDB[j].coalition]
                    end
                end
            end
        end

        table.sort(tmp,tsort)


--[[
SIDE    TYPE            BRG          RNG         ALT       SPD        HDG
BLUE    MiG-29S         195/015    149.5 km    12455 m     495 kph    045
RED     F-16C bl.52d    025/205     26.2 km     1223 m    1053 kph    214
--]]

        -- build display table
        if #tmp > 0 then

			-- display header
            local awacsDisplay = {}
            awacsDisplay[#awacsDisplay + 1] = "\n"
            awacsDisplay[#awacsDisplay + 1] = "AWACS Picture (Reference: "..reference..")"
            awacsDisplay[#awacsDisplay + 1] = "\n"
			awacsDisplay[#awacsDisplay + 1] = string.format( "%-8s"   , "SIDE"  )
			awacsDisplay[#awacsDisplay + 1] = string.format( "%-16s"  , "TYPE"  )
			awacsDisplay[#awacsDisplay + 1] = string.format( "%-12s"  , "BRG"   )
			awacsDisplay[#awacsDisplay + 1] = string.format( "%-12s"  , "RNG" )
			awacsDisplay[#awacsDisplay + 1] = string.format( "%-10s"  , "ALT" )
			awacsDisplay[#awacsDisplay + 1] = string.format( "%-10s " , "SPD" )
			awacsDisplay[#awacsDisplay + 1] = string.format( "%-3s"   , "HDG"   )

			-- display body
            for k=1,#tmp do
                awacsDisplay[#awacsDisplay + 1] = "\n"
                awacsDisplay[#awacsDisplay + 1] = string.format( "%-8s"      , tmp[k].coaName             )
                awacsDisplay[#awacsDisplay + 1] = string.format( "%-16s"     , tmp[k].unitType            )
                awacsDisplay[#awacsDisplay + 1] = string.format( "%03d"      , tmp[k].bearing             )
                awacsDisplay[#awacsDisplay + 1] = string.format( "/%03d"     , tmp[k].reciprocalBrg       )
                awacsDisplay[#awacsDisplay + 1] = string.format( "%8.1f %s"  , tmp[k].range       , "km"  )
                awacsDisplay[#awacsDisplay + 1] = string.format( "%9d %s"    , tmp[k].altitude    , "m"   )
                awacsDisplay[#awacsDisplay + 1] = string.format( "%8d %s"    , tmp[k].speed * 3.6 , "kph" )
                awacsDisplay[#awacsDisplay + 1] = string.format( "    %03d"  , tmp[k].heading             )
            end

            trigger.action.outTextForGroup( awacsID, table.concat(awacsDisplay), 10 )

        end
    end

end

awacs.schedInstallCommands = function(arg, time)

    awacs.getAwacsUnits()
    for i=1,#awacs.awacsUnits do
        awacs.installAwacsCommands(awacs.awacsUnits[i].unitName)
    end

    return time + 5

end

awacs.schedUpdateAwacs = function(arg, time)
	awacs.updateAwacs()
	return time + 30
end

do
    timer.scheduleFunction( awacs.schedInstallCommands, nil, timer.getTime() + 5 )
    timer.scheduleFunction( awacs.schedUpdateAwacs    , nil, timer.getTime() + 100 )
end
